/*  Sesame - Storage and Querying architecture for RDF and RDF Schema
 *  Copyright (C) 2001-2006 Aduna
 *
 *  Contact: 
 *  	Aduna
 *  	Prinses Julianaplein 14 b
 *  	3817 CS Amersfoort
 *  	The Netherlands
 *  	tel. +33 (0)33 465 99 87
 *  	fax. +33 (0)33 465 99 87
 *
 *  	http://aduna-software.com/
 *  	http://www.openrdf.org/
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.openrdf.sesame.sailimpl.memory;

import org.openrdf.model.Resource;
import org.openrdf.model.URI;
import org.openrdf.model.Value;
import org.openrdf.model.impl.StatementImpl;

/**
 * A MemStatement is a Statement which has a flag setting indicating
 * whether the statement is explicit or inferred.
 *
 * @author Jeen Broekstra
 * @version $Revision: 1.4.4.2 $
 */
public class MemStatement extends StatementImpl {

	private boolean _explicit;

	public MemStatement(Resource subject, URI predicate, Value object) {
		super(subject, predicate, object);
		_explicit = true;
	}

	public MemStatement(Resource subject, URI predicate, Value object, boolean explicit) {
		super(subject, predicate, object);
		_explicit = explicit;
	}

	public void setExplicit(boolean explicit) {
		_explicit = explicit;
	}

	public boolean isExplicit() {
		return _explicit;
	}
}	
